#!/usr/bin/env python3
# -*- coding: utf-8; py-indent-offset: 4 -*-


#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*

# Native Python Lib/Class 
import json
import threading
import time

# bmSearch Class
import config as CFG
from logger import *
from batchParser import *

class bmBatch:
    """
        bmBatch Class 
            main class from which we call all methods/classes to parse, retrieve pertinent values and post then to an Elasticsearch engine.
    """

    def __init__(self,**kwargs):                
        """
            __init__ :
                constructor accept kwargs

                **kwargs: 
                    file   : path to file to parse. I can be plain text, gzip or bzip2 compressed. By default what configured in /etc/bmSearch/config.py

                    method : how to read the file, 2 possibilities
                        - "file" : read the file and exit after reach end file. By default.
                        - "stream" : connect to the file and stream data. No exit while programm running

                    action : tell what to do, 2 cases
                        - "storeToELK"  : to store in Elasticsearch instance configured in /etc/bmSearch/config.py
                        - "updateToELK" : to update in Elasticsearch instance data (deliveredRecip)
                                        
                Constructor call mailLogParser(**kwargs), mailLogParser().getFileContent(), mailLogParser().parseContent() and mailLogParser().updateEntry()
                
        """
        
        """
        LOGGER
        """
        
        backoffice = logger().setLogger()
        try:
            self.p = batchParser()
            self.p.setParam(**dict(kwargs))
            self.p.readFile()
            self.p.pushToELK()

        except Exception as e:
            backoffice.critical(e)



