#!/usr/bin/env python3
# -*- coding: utf-8; py-indent-offset: 4 -*-


#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*

# Native Python Lib/Class 
from collections import defaultdict


class bmObject:
    
    def __init__(self):
        self.objet=defaultdict(dict)
    

    def initMsgObj(self):
        self.objet['@timestamp'] = ""
        self.objet['date']       = ""
        self.objet['hour']       = ""
        self.objet['server']     = ""

        #ElasticEntries
        self.objet['source'] = ""
        self.objet['type']   = 'message'

        self.objet['beat'] = defaultdict(dict)
        self.objet['beat']['hostname'] = ""
        self.objet['beat']['name']     = 'bmsearch'
        self.objet['beat']['version']  = ""

        self.objet['msgid']     = "this-is-not-a-msgid@bmsearch.local"
        self.objet['userAgent'] = "Unknown"

        self.objet['from']     = self.objet['fromDomain'] = self.objet['nrcpt']          = self.objet['size']        = ""
        self.objet['bodyDate'] = self.objet['bodyFrom']   = self.objet['bodyFromDomain'] = self.objet['bodySubject'] = ""

        self.objet['antivirus'] = 'CLEAN : not analyzed!'

        self.objet['filename'] = []
        self.objet['recip']    = []

        self.objet['fileType'] = defaultdict(dict)
 
        return self.objet


    def passedThroughObj(self):           
        self.objet['@timestamp'] = ""
        self.objet['date']       = ""
        self.objet['hour']       = ""

        #ElasticEntries
        self.objet['source'] = ""
        self.objet['type']   = 'message'

        self.objet['beat'] = defaultdict(dict)
        self.objet['beat']['hostname'] = ""
        self.objet['beat']['name']     = 'bmsearch'
        self.objet['beat']['version']  = ""

        self.objet['server']  = ""
        self.objet['msgid']   = "this-is-not-a-msgid@bmsearch.local"         
        self.objet['queueid'] = ""
        self.objet['log']     = ""

        return self.objet



    def dsnObj(self):
        self.objet['@timestamp'] = ""
        self.objet['date']        = ""
        self.objet['hour']        = ""

                #ElasticEntries
        self.objet['source'] = ""
        self.objet['type']   = 'message'

        self.objet['beat'] = defaultdict(dict)
        self.objet['beat']['hostname'] = ""
        self.objet['beat']['name']     = 'bmsearch'
        self.objet['beat']['version']  = ""

        self.objet['recip']  = ""
        self.objet['domain'] = ""
                
        self.objet['dsn'] = defaultdict(dict)
        self.objet['dsn']['queueid'] = ""
        self.objet['dsn']['status']  = ""
        self.objet['dsn']['log']     = ""

        return self.objet
        
    def cyrusDeliveryObj(self):
        self.objet['@timestamp'] = ""
        self.objet['date']       = ""
        self.objet['hour']       = ""

        #ElasticEntries
        self.objet['source'] = ""
        self.objet['type']   = 'message'

        self.objet['beat'] = defaultdict(dict)
        self.objet['beat']['hostname'] = ""
        self.objet['beat']['name']     = 'bmsearch'
        self.objet['beat']['version']  = ""

        self.objet['recip']  = ""
        self.objet['domain'] = ""
                
        self.objet['delivery'] = defaultdict(dict)
        self.objet['delivery']['msgid'] = "this-is-not-a-msgid@bmsearch.local"
        self.objet['delivery']['log']   = ""
        
        return self.objet
        
        
    def cyrusLoginObj(self):
        self.objet['@timestamp'] = ""
        self.objet['date']       = ""
        self.objet['hour']       = ""

        #ElasticEntries
        self.objet['source'] = ""
        self.objet['type']   = 'message'

        self.objet['beat'] = defaultdict(dict)
        self.objet['beat']['hostname'] = ""
        self.objet['beat']['name']     = 'bmsearch'
        self.objet['beat']['version']  = ""

        self.objet['user']   = ""
        self.objet['ipAddr'] = ""
        self.objet['log']    = ""

        return self.objet
        
        
        
        
        
        
        
        
        
        
        
        
