#!/usr/bin/env python3
# -*- coding: utf-8; py-indent-offset: 4 -*-


#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*

#NativePythonLib/Class
import base64
from collections import defaultdict
    
from datetime import *
import hashlib
import json
import magic
import os
import sys

import time


#bmSearchClass
import config as CFG
from requestToELK import *
from sqlQuery import *

from logger import *
backoffice = logger().setLogger().getChild('jobEveryMin')


class jobEveryMin:
    """
    mailLogParser:
    Hastoopen/streammail.logfile,
    parseeachlinetofeedadictwithpertinentvalues
    andtry(ifkwargsset)topublishtheminELKplatform
    """

    def __init__(self):
        """
        __init__:
        """

        self.minutes = 10 #1 day
        
        """
        Session Pool connection
        """
        self.s = requestToELK()
        self.s.initSession()


    def setParam(self,**kwargs):     
        
        self.dbStore = CFG.dbStore
        if "dbStore" in kwargs.keys():
            self.dbStore = kwargs['dbStore']

        self.dbtemp = CFG.dbtemp
        if "dbtemp" in kwargs.keys():
            self.dbStore = kwargs['dbtemp']

        self.method = "file"
        if "method" in kwargs.keys():
            self.method = kwargs['method']


    def connectToDb(self):
        """
        OpenSQLITEDB
        """
        if self.method == "file":
            db = self.dbtemp
        if self.method == "stream":
            db = self.dbStore
        self.cDb = sqlQuery(db)





    def storeFromQueueObjToELK(self):
        """
            storeFomQueueObjToELK:
            
        """
        tmstp = round(time.time()) - (60*self.minutes)
        
        #1 Retrieve all entries older than tmstp
        qList = self.cDb.getAllQueueidOlderThan(str(tmstp))
       
        #2 For all queueid try to store data to ELK 
        if (qList is not None) and (len(qList)>0) : 
            res = False
            for queueid in qList:
                if self.forcePostDataToELK(queueid):
                    self.deleteSqlObj(queueid)
  

    
    def forcePostDataToELK(self,queueid):
        """
            forcePostDataToELK:
                retrieve obj from sqlite and post data to ELK 
        """
        r = False
        storedQueueObjJSON = str(self.cDb.getQueueObj(queueid))
        storedQueueObj = json.loads(storedQueueObjJSON)      
        
        res = self.s.sendDataAboutYesterday(storedQueueObj)
        if res:
            r = True
            messageid = storedQueueObj['msgid']
            timestamp = int(storedQueueObj['@timestamp'])/1000           
                    
            msg = "[Forced] Post to ELK message referenced with msgid " + storedQueueObj['msgid']
            backoffice.info(msg)

            try:
                # Store messageid DB in case of bmSearch restart
                tupl = (messageid,timestamp)
                self.cDb.addEntry(tupl)
            except  KeyError:
                pass
        return r
    
    
    
    def deleteSqlObj(self,queueid):
        """
            deleteSqlObj:
                delete object in sqlite DB 
        """
        self.cDb.deleteQueueObj(queueid)


    

