#!/bin/bash

#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*

# Remove the /var/log/mail* entries int the /etc/logrotate.d/syslog-g file
# 
#



file="/etc/logrotate.d/syslog-ng"

# First : doing a backup of this file
cp $file $file"-BM-BacKup.disabled"


parse_bloc() {

        first_line=$1
        file=$2
        ctrl_ok=

        for ((i=first_line;;i++))
        do
                mail_ctrl=`sed -n "$i"p $file`
                ligne_blanche=`sed -n "$i"p $file`

                if [ "$mail_ctrl" = "" ]; then
                        mail_ctrl=a
                fi

                if [ "$mail_ctrl" = "}" ]; then
                	ctrl_ok=1
                fi

                if [ "$ligne_blanche" = "" -a "$ctrl_ok" = "1" ]; then
                        iprev=$(($i-1));
                        echo "$first_line,$iprev"
                        break
                fi

                if [ "$ligne_blanche" = "" -a "$ctrl_ok" != "1" ]; then
                        echo "zz"
                        break
                fi

        done

}

deleting_mail_bloc() {

        line_mail=$1
        file=$2

        is_this_bloc=""

        # Getting the line numbers for each block in $file
        is_this_bloc=$(parse_bloc "$line_mail" $file);

        if [ "$is_this_bloc" != "zz" ]; then
                echo "deleting lines $is_this_bloc"
                sed -i "$is_this_bloc"d $file
        fi

}

# Parse $file to get the line number of each line '/var/log/mail."

line_mail=`grep -m 1 -n '/var/log/mail' $file | cut -d : -f 1`

while [ "$line_mail" ]
do

        deleting_mail_bloc "$line_mail" $file
        line_mail=`grep -m 1 -n '/var/log/mail' $file | cut -d : -f 1`

done

exit 0 ;
