#!/bin/bash

#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*


PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

# Author : Pascal Salaun <pascal.salaun@laposte.net>
# Description : do a logrotate of the mail.log file.
# Because these one can be hugh (over 1Go/day), the current savelog command
# will take too much time. (2 minutes for a 3.5Go file)
# So, this method will take only 1-2 seconds.



logFile=$(sed '/^maillog/!d' /etc/bmSearch/config.py | tr -s " " | cut -d '=' -f2 | sed -e 's/"//g' -e "s/'//g")
maillog=${logFile##*/}
MailLogDestDir=$(dirname $logFile)"/mail/"



LogDaemon="rsyslog"
Ownership=`ls -l $logFile |tr -s " "|cut -d " " -f3,4|sed 's/ /:/'`


# Control
if [ ! -d $MailLogDestDir ]; then
        mkdir -p $MailLogDestDir
fi


# Get log daemon name (rsyslog/syslog-ng/sysklogd)
if [ "$LogDaemon" = "" ] ; then
	LogDaemon=`dpkg -l "*sys*log*" | grep ii | grep -iv perl | tr -s ' ' | cut -d ' ' -f2| grep -v system`
fi


# Logrotate

mv $logFile".0" $logFile"."`date --date '2 days ago' +%F`
mv $logFile $logFile".0"

touch $logFile
chown $Ownership $logFile
chmod 662 $logFile


# Restart LogDaemon
#/etc/init.d/$LogDaemon restart
service $LogDaemon restart

# renamming, compressing, archiving mail.log.1
gzip -c $logFile"."`date --date '2 days ago' +%F` > $logFile"."`date --date '2 days ago' +%F`.gz
mv $logFile"."`date --date '2 days ago' +%F`.gz $MailLogDestDir


# deleting the uncompressed mail.log.yyyy-mm-dd
rm -f  $logFile"."`date --date '2 days ago' +%F`

# deleting the compressed file older than 1 year
rm -f  $MailLogDestDir$maillog."`date --date '365 days ago' +%F`.gz

exit 0 ;

