#!/bin/bash

#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

chmod 644 /etc/cron.d/bmSearch 

###  Check if bm-stats is already installed  ####
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "Oh, bm-stats is installed, thanks a lot !"
        echo " We are just disabling mail log rotation from bmSearch cron file"
        
        sed -i -e "s/\(.*#bmStatsAlreadyInstalled.*\)/#\1/" -e "/^#/s/#\{2,\}/#/g" /etc/cron.d/bmSearch

fi


### Setting Logs Management####
# which daemon (rsyslog|syslog-ng|sysklogd) 
DaemomLog=`dpkg -l "*sys*log*" | grep ii | tr -s ' ' | cut -d ' ' -f2 | grep -v system|grep -v lib`
	    
if [ "$DaemomLog" = "rsyslog" ]; then
	if [ -f /etc/logrotate.d/rsyslog ]; then
		echo "Configuring /etc/logrotate.d/rsyslog"
		sed -i 's/\(^\/var\/log\/mail.*\)/#\1/g'  /etc/logrotate.d/rsyslog
	fi
fi

if [ "$DaemomLog" = "syslog-ng" ]; then
	if [ -f /etc/logrotate.d/syslog-ng ]; then
		echo "Configuring /etc/logrotate.d/syslog-ng"
		echo "The previous one saved as /etc/logrotate.d/syslog-ng-bmStats-BacKup.disabled"
		/usr/share/bmSearch/scripts/SHELL/Logrotate-SyslogNG-No-MailLog.sh
	fi
fi

echo "A logrotate of mail.log file will now be done each day at 00:00, and the the filelog \"2 days old\" "
echo "will be moved in /var/log/mail/ ";
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
else
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
fi

DATE=$(date +%F_%H-%M-%S)
sed -i.bmSearch.${DATE} '/^\*\.\*.*local5.none.*/!s/\*\.\*;/\*\.\*;local5.none;/' /etc/rsyslog.conf

if diff -q /etc/rsyslog.conf /etc/rsyslog.conf.bmSearch.${DATE} ; then
    rm -f /etc/rsyslog.conf.bmSearch.${DATE}
fi

FileOwner=$(grep FileOwner /etc/rsyslog.conf|cut -d " " -f2)
FileGroup=$(grep FileGroup /etc/rsyslog.conf|cut -d " " -f2)
CMD="chown $FileOwner.$FileGroup -R /var/log/bmSearch"
eval $CMD

echo ""
echo "Redirecting Logs from local5" 
if [ ! -f /etc/rsyslog.d/10-bmSearch.conf ] ; then
    cp /usr/share/bmSearch/scripts/sample/rsyslog_bmSearch.sample /etc/rsyslog.d/10-bmSearch.conf
    echo "You can configure /etc/rsyslog.d/10-bmSearch.conf with your own values"
fi
service rsyslog restart


echo ""
echo "Define log rotation " 
if [ ! -f /etc/logrotate.d/bmSearch ] ; then
    cp /usr/share/bmSearch/scripts/sample/logrotate_bmSearch.sample /etc/logrotate.d/bmSearch
    echo "You can configure /etc/logrotate.d/bmSearch with your own values"
fi

exit 0
