#!/bin/bash

# **
# * ------------------------------------------------------------------------
# * bmSearch
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://bm-monitor.org/ <http://bm-monitor.org/>
# * ---

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

chmod 644 /etc/cron.d/bmSearch 
    
###  Check if bm-stats is already installed  ####
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "Oh, bm-stats is installed, thanks a lot !"
        echo " We are just disabling mail log rotation from bmSearch cron file"
        
        sed -i -e "s/\(.*#bmStatsAlreadyInstalled.*\)/#\1/" -e "/^#/s/#\{2,\}/#/g" /etc/cron.d/bmSearch

fi

### Setting Logs Management####
# which daemon (rsyslog|syslog-ng|sysklogd) 
DaemomLog=`yum -q list installed "*sys*log*" |sed 1d | tr -s " "|cut -d"." -f1`
	    
if [ "$DaemomLog" = "rsyslog" ]; then
	if [ -f /etc/logrotate.d/syslog ]; then
		echo "Configuring rsyslog and /etc/logrotate.d/rsyslog"
		sed -i 's/maillog/mail\.log/' /etc/rsyslog.conf
		mv /var/log/maillog /var/log/mail.log
		/etc/init.d/rsyslog restart
		sed -i '/maillog/d' /etc/logrotate.d/syslog
		echo "Restarting rsyslog..."
		/etc/init.d/rsyslog restart
	fi
fi

if [ "$DaemomLog" = "syslog-ng" ]; then
	if [ -f /etc/logrotate.d/syslog ]; then
		echo "Configuring syslog-ng and /etc/logrotate.d/syslog-ng"
		sed -i '/maillog/d' /etc/logrotate.d/syslog
		sed -i 's/maillog/mail\.log/' /etc/syslog-ng/syslog-ng.conf
		sed -i 's/LogDaemon="rsyslog"/LogDaemon="syslog-ng"/' /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh
		echo "Restarting syslog-ng..."
		/etc/init.d/syslog-ng restart
	fi
fi

echo "A logrotate of mail.log file will now be done each day at 00:00, and the the filelog \"2 days old\" "
echo "will be moved in /var/log/mail/ ";

if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
else
        echo "See /usr/share/bmSearch/scripts/SHELL/MailLogRotate.sh for details"
fi

echo ""
echo "Redirecting Logs from local5" 
if [ ! -f /etc/rsyslog.d/10-bmSearch.conf ] ; then
    cp /usr/share/bmSearch/scripts/sample/rsyslog_bmSearch.sample /etc/rsyslog.d/10-bmSearch.conf
    echo "You can configure /etc/rsyslog.d/10-bmSearch.conf with your own values"
fi
service rsyslog restart


echo ""
echo "Define log rotation " 
if [ ! -f /etc/logrotate.d/bmSearch ] ; then
    cp /usr/share/bmSearch/scripts/sample/logrotate_bmSearch.sample /etc/logrotate.d/bmSearch
    echo "You can configure /etc/logrotate.d/bmSearch with your own values"
fi


exit 0
