#!/bin/bash

#  +-- bmSearch ------------------------------------------------------------------+
#  |                                                                              |
#  |  _                 _____                          _                          |
#  | | |               / ____|                        | |                         | 
#  | | |___  _ __ ___ | |____    ___  ____   _ _  ___ | |__                       |
#  | |  _  \| '_ ` _ \ \___  \  / _ \|___ \ | `_|/ __||  _  \                     | 
#  | | |_| || | | | | |____|  ||  __// __  || | | |__ | | | |                     |
#  | |_____/|_| |_| |_|______/  \___|\____/ |_|  \___||_| |_|                     |
#  |                                                                              |
#  |                                                                              |
#  +------------------------------------------------------------------------------+
#
# * ----------------------------------------------------------------------------------------*
# * @author  : Pascal SALAUN <pascal.salaun-AT-bm-monitor.org>                              *
# * @Website : http://www.bm-monitor.org <http://www.bm-monitor.org>                        *
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>    *
# *                                                                                         *
# * bmSearch is free software;  you can redistribute it and/or modify it under the          *
# *  terms of the  license mentionned above.                                                *
# * bmSearch is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY    * 
# * ----------------------------------------------------------------------------------------*


chmod -x /lib/systemd/system/bmSearch.service

###  Check if bm-stats is already installed  ####
if [ -f "/usr/share/bm-stats/scripts/SHELL/MailLogRotate.sh" ] ; then
        echo "Oh, bm-stats is installed, thanks a lot !"
        echo " We are just disabling mail log rotation from bmSearch cron file"
        
	sed -i -e "s/\(.*#bmStatsAlreadyInstalled.*\)/#\1/" -e "/^#/s/#\{2,\}/#/g" /etc/cron.d/bmSearch
fi


if [ ! -f "/usr/share/bmSearch/inc/regex.py" ] ; then
    cp /usr/share/bmSearch/inc/regex.py.sample /usr/share/bmSearch/inc/regex.py
fi



#
# Logging Stuff
#
restartRsyslog=false

DATE=$(date +%F_%H-%M-%S)
sed -i.bmSearch.${DATE} '/^\*\.\*.*local5.none.*/!s/\*\.\*;/\*\.\*;local5.none;/' /etc/rsyslog.conf

if diff -q /etc/rsyslog.conf /etc/rsyslog.conf.bmSearch.${DATE} ; then
    rm -f /etc/rsyslog.conf.bmSearch.${DATE}
else
    restartRsyslog=true
fi

FileOwner=$(grep FileOwner /etc/rsyslog.conf|cut -d " " -f2)
FileGroup=$(grep FileGroup /etc/rsyslog.conf|cut -d " " -f2)
CMD="chown $FileOwner.$FileGroup -R /var/log/bmSearch"
eval $CMD


if [ ! -f "/etc/cron.d/bmSearch" ] ; then
    cp /usr/share/bmSearch/scripts/templates/etc_crond/bmSearch /etc/cron.d/bmSearch
fi

chmod 644 /etc/cron.d/bmSearch 

if [ ! -f "/usr/share/bmSearch/class/logger.py" ] ; then
    cp /usr/share/bmSearch/class/logger.py.sample /usr/share/bmSearch/class/logger.py
fi


if [ -f /etc/logrotate.d/bmSearch ] ; then
    chmod 644 /etc/logrotate.d/bmSearch
else
    cp /usr/share/bmSearch/scripts/templates/etc_logrotated/bmSearch.tpl /etc/logrotate.d/bmSearch
    chmod 644 /etc/logrotate.d/bmSearch
fi


if [ -f /etc/rsyslog.d/10-bmSearch.conf ] ; then
    chmod 644 /etc/rsyslog.d/10-bmSearch.conf
else
    cp /usr/share/bmSearch/scripts/templates/etc_rsyslogd/10-bmSearch.conf.tpl /etc/rsyslog.d/10-bmSearch.conf
    chmod 644 /etc/rsyslog.d/10-bmSearch.conf
    restartRsyslog=true
fi

if $restartRsyslog ; then 
    service rsyslog restart
fi








exit 0
